package edu.upvehu.gb.tap;

import edu.upvehu.gb.tap.tipografias.Grapheme;
import edu.upvehu.gb.tap.tipografias.Typography;
import edu.upvehu.gb.tap.tipografias.Typography1;
import edu.upvehu.gb.tap.tipografias.Typography2;

/**
 *
 * @author Clase
 */
public class Graphemes {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        
        Typography t ;
        t=new Typography1();
        System.out.println(Graphemes.toString(t,'H'));
        System.out.println(Graphemes.toString(t,6,'E'));
        System.out.println(Graphemes.toString(t,6,'L'));
        System.out.println(Graphemes.toString(t,8,'L'));
        System.out.println(Graphemes.toString(t,10,'O'));
        System.out.println(Graphemes.toString(t,"HELLO"));
        System.out.println(Graphemes.toString(t,10,"HELLO"));
        
        t=new Typography2();
        System.out.println(Graphemes.toString(t,'H'));
        System.out.println(Graphemes.toString(t,6,'E'));
        System.out.println(Graphemes.toString(t,6,'L'));
        System.out.println(Graphemes.toString(t,8,'L'));
        System.out.println(Graphemes.toString(t,10,'O'));
        System.out.println(Graphemes.toString(t,"HELLO"));
        System.out.println(Graphemes.toString(t,10,"HELLO"));

        
    }
    
    public static String toString(Typography t, char c){
        return toString(t,""+c);
    }
    public static String toString(Typography t, int size, char c){
        return toString(t,size,""+c);
    }
    
    public static String toString(Typography t, String s){
    String[][] patterns=new String[s.length()][];
        for (int i=0;i<patterns.length;i++) {
            patterns[i]=t.valueOf(s.charAt(i)).createPattern();
        }
        return renderiza(patterns);
    }
    
    public static String toString(Typography t, int size, String s){
        String[][] patterns=new String[s.length()][];
        for (int i=0;i<patterns.length;i++) {
            Grapheme g=t.valueOf(s.charAt(i));
            g.setSize(size);
            patterns[i]=g.createPattern();
        }
        return renderiza(patterns);
    }
    
    
    public static String renderiza(String[][] patterns){
        StringBuilder sb = new StringBuilder();
        for (int j=0;j<patterns[0].length;j++)   {
            for (int i=0; i<patterns.length; i++) sb.append(patterns[i][j]).append(' ');
            sb.append('\n');
        }
        return sb.toString();
    }
  
}
