package edu.upvehu.gb.tap.tipografias;

import java.util.Arrays;

/**
 *
 * @author Clase
 */
public class Typography1 implements Typography{
    private static final char BLACK='X';
    
    @Override
    public Grapheme valueOf(char c) {
        return DefaultGrapheme.getInstance(c,this);
    }

    @Override
    public String toString() {
        return "{Typography1}";
    }
    
    
    
        public String[] createPattern(char character, int size) {
         String[] pattern=null;
         char[] line=new char[size];
         switch (character) {
             case 'H':
                 pattern=backgroundPattern(bothLines(size));
                 pattern[size/2]=fullLine(size);
                 break;
            case 'E':
                 pattern=backgroundPattern(leftLine(size));
                 pattern[0]=pattern[size/2]=pattern[size-1]=fullLine(size);
                 break;
            case 'L':
                 pattern=backgroundPattern(leftLine(size));
                 pattern[size-1]=fullLine(size);
                 break;
            case 'O':
                 pattern=backgroundPattern(bothLines(size));
                 pattern[0]=pattern[size-1]=fullLine(size);
                 break;
         }
         return pattern;
     }
        
    //Métodos de utilidad    
    //**********************************************************
    String[] backgroundPattern(String s){
        String[] pattern=new String[s.length()];
        for (int i=0;i<pattern.length;i++) pattern[i]=s;
        return pattern;
    }
     
    String fullLine=null; 
    String fullLine(int size) {
        if (fullLine!=null && fullLine.length()==size) return fullLine;
        char[] line=new char[size];
        Arrays.fill(line,BLACK);
        return fullLine=new String(line);
    }
    String leftLine=null; 
    String leftLine(int size) {
        if (leftLine!=null && leftLine.length()==size) return leftLine;
         char[] line=new char[size];
         Arrays.fill(line,' ');line[0]=BLACK;
         return leftLine=new String(line);
    }
    String rightLine=null; 
    String rightLine(int size) {
        if (rightLine!=null && rightLine.length()==size) return rightLine;
         char[] line=new char[size];
         Arrays.fill(line,' ');line[size-1]=BLACK;
         return rightLine=new String(line);
    }
    String bothLines=null; 
    String bothLines(int size) {
        if (bothLines!=null && bothLines.length()==size) return bothLines;
         char[] line=new char[size];
         Arrays.fill(line,' ');line[0]=line[size-1]=BLACK;
         return bothLines=new String(line);
    }
    String middleLine=null; 
    String middleLine(int size) {
        if (middleLine!=null && middleLine.length()==size) return middleLine;
         char[] line=new char[size];
         Arrays.fill(line,' ');line[size/2]=BLACK;
         return middleLine=new String(line);
    }
   
    
}
